#ifndef LIBSA
#define LIBSA
namespace LIBSA {
	class Receptor {
	public:
		std::vector<float> x, y, z, alpha, beta;
		std::vector<std::string> header, atomName, residue, chain, element;
		std::vector<int> atomIndex, residueIndex;
		std::vector<unsigned int> atomHitFrequency;
		bool parse_receptor(LIBSA::Receptor*, LIBSA::Receptor**, char*);
		void add_node(LIBSA::Receptor*, LIBSA::Receptor**, char*);
		void print_receptor_list_summary(LIBSA::Receptor*);
		void delete_node(LIBSA::Receptor*, LIBSA::Receptor**, unsigned int);
		void delete_head_node(LIBSA::Receptor *, LIBSA::Receptor **);
		bool isAtomRecord (std::string);
		void findMaxResID (LIBSA::Receptor *, int *);
		Receptor *next;
	private:
	};

	class Ligand {
	public:
		float affinity;
		std::vector<float> x, y, z, vdw, elec;
		std::vector<std::string> header, atomType, atomName, residue, type;
		std::vector<unsigned int> atomIndex, residueIndex;
		bool parse_ligand(LIBSA::Ligand*, LIBSA::Ligand**, char*);
		void add_ligand_nodes(LIBSA::Ligand*, LIBSA::Ligand **, char *);
		void initialize_list(LIBSA::Ligand*, LIBSA::Ligand **, char *);
		void delete_node(LIBSA::Ligand*, LIBSA::Ligand**, unsigned int);
		bool isAtomRecord(std::string);
		bool isAffinityRecord(std::string);
		bool isMODEL(std::string);
		bool isENDMDL(std::string);
		void print_ligand_list_summary(LIBSA::Ligand *); 
		void delete_head_node(LIBSA::Ligand *, LIBSA::Ligand **);
		void affinity_filter(std::vector<float>, std::vector<unsigned int>&);
		Ligand *next;
	private:
	};
} //End LIBSA namespace declaration
#endif

