#include "LIBSA.h"
//#include "ligand_parser.cpp"
using namespace std;
#define ENERGY_STEP_SIZE_GOAL 0.05 //define the binning width in kcal/mol.  

bool myfunction (int i,int j) { return (i<j); }

void LIBSA::Ligand::affinity_filter(vector<float> affinity, vector<unsigned int> &nodes_to_delete) 
{
	bool display = 0;
	vector<float> energy = affinity;
	if ( energy.size() < 1 ) {
   	cout << "The length of the input file is zero" << endl;
   	return;
   	}

    float min = energy[0];
   	float max = energy[0];
   	for (unsigned int i=1;i<energy.size();i++)
	{
		if (energy[i] > max)
		{
	   	max = energy[i];
		}
		if (energy[i] < min)
		{
	      min = energy[i];
		}
	}
	
	if (min < -16) {
		min = min;
	} else {
		min = -16;
	}
	max = 0;
	float range = max - min; //define the range ie the x-axis
   	//display the elements if you wish
   	if ( display )
	{
		cout << "The energy values are:" << endl;
		for (unsigned int i=0; i < energy.size(); i++)
			cout << " " << energy[i] << endl;
		cout << "There are " << energy.size() << " elements in the file" << endl;
		cout << "The range is " << range << endl;
		cout << "The max value is " << max << endl;
		cout << "The minimum value is " << min << endl;
	}
	
	cout << "REMARK:MAX " << max << endl;
	cout << "REMARK:MIN " << min << endl;
	
   	int num_bin = 1000;
   	float step = range / num_bin;
   	float step_temp = 0;
   	float del1 = 0;
   	float del2 = 0;
	//optimization of the differene between the energy step goal and the actual step size
   	while ( step <= ENERGY_STEP_SIZE_GOAL ) { //approximate max bin width
		step_temp = step;
		num_bin = num_bin - 1;  //decrease the bin width by one until the step approaches ENERGY_STEP_SIZE_GOAL
		step = range / num_bin;
		if (debug) cout << "DEBUG:RESIZE-BIN " << step_temp << "(" << num_bin+1 << ")" << "_to_" << step << "(" << num_bin << ")" << endl;
   	}
   	float temp_num_bin = num_bin + 1;
   	del1 = abs( ENERGY_STEP_SIZE_GOAL - (range / num_bin) ); //current step size
   	del2 = abs( ENERGY_STEP_SIZE_GOAL - (range / temp_num_bin) ); //previous step size
   	if (del2 < del1) {
   	cout << "REMARK:REVERSING_STEP_SIZE_TO " << num_bin + 1 << endl;
   	cout << "REMARK:DELTA1_2_DELTA1_COMPARISON " << del1 << "_>_" << del2 << endl;
   	num_bin = num_bin + 1;
   	step = range / num_bin;
   	} else {
		cout << "REMARK:CURRENT_STEP_IS_BEST " << num_bin << endl;
		cout << "REMARK:DELTA1_2_DELTA1_COMPARISON " << del1 << " < " << del2 << endl;
   	}
   
   	cout << "REMARK:STEP_SIZE " << step << endl;
   	cout << "REMARK:NUM-BIN " << num_bin << endl;
   	cout << "REMARK:PLOT_X-AXIS_IS_LEFT_BIN_VALUE" << endl;
   	float max_pos = max; //use the maximum because we are working with negative values only
   	float current_pos = min; //the most left value on the X-axis
   	vector<float> height; //vector to hold the un-normalized values
   	vector<float> energy_axis;
	vector<float> lower_energy;
	vector<float> upper_energy;
	vector<float> frames;
   	while ( current_pos <= max_pos )
	{
     	energy_axis.push_back(current_pos); //use the left bin value...add step to current_pos to get the right value i.e. energy_axis.push_back(curent_pos+step)
        float count = 0;
		float lower = current_pos;
		float upper = (current_pos + step);
		if (debug) cout << "DEBUG:POSITIONS " << current_pos << " + " << step << " = " << current_pos+step << endl;
		for (unsigned int i=0;i<energy.size();i++)
		{
			if (  (lower <= energy[i]) && (energy[i] <= upper) && (lower == min)  )
			{
				if (debug) cout << "DEBUG: " << lower << " <= " << energy[i] << "........." << upper << " > " << energy[i] << endl;
				count = count + 1; //the number of "ligand-poses" within each bin
				frames.push_back(i); 
				lower_energy.push_back(lower); //construct a vector of the left-bin values
				upper_energy.push_back(upper); //construct a vector of the right-bin values
			}
			if (  (lower < energy[i] ) && (energy[i] <= upper) && (lower != min)  )
			{
				if (debug) cout << "DEBUG: " << lower << " <= " << energy[i] << "........." << upper << " > " << energy[i] << endl;
				count = count + 1; //the number of "ligand-poses" within each bin
				frames.push_back(i); 
				lower_energy.push_back(lower); //construct a vector of the left-bin values
				upper_energy.push_back(upper); //construct a vector of the right-bin values
			}
		}
		height.push_back(count);
		count = 0;
		//increase the counter to the end of the range
		current_pos = current_pos + step;
	}
	if (debug) cout << "DEBUG:found this many frames " << frames.size() << " and this many energy pairs " << lower_energy.size() << " " << upper_energy.size() << endl;
	for (unsigned int i=0;i<height.size();i++) { //when printing out the PLOT X & Y values, remember that the X value is the left-bin value. thus the right bin value is the Lvalue plus the "step" variable
		cout << "PLOT: " << energy_axis[i] << " " << height[i] << endl;
	}
	
	//sort the data in descending order
	vector<float> height_sorted = height;
	sort(height_sorted.begin(), height_sorted.end(), my_sort_function_descending);
	
	if (debug) for (unsigned int i=0;i<height.size();i++) {
		cout << "DEBUG: BIN " << i << " HEIGHT " << height[i] << endl;
		cout << "DEBUG:SIZE_CHECK " << height_sorted.size() << " " << height.size() << endl;
	}
	
	//count the height values values to see if equals the input
	unsigned int sum = 0;
	for (unsigned int i=0;i<height.size();i++) {
		sum = sum + (int)height[i];
	}
	cout << "REMARK:HEIGHT-SUMMATION " << sum << ", should equal " << energy.size() << endl;
	
	//check to make sure we are not losing data
	if ( sum != energy.size() ) {
		print_death();
		cout << "---WARNING:BINNED-DATA-LOSS" << endl;
		cout << "---WARNING:" << sum << "-DOES-NOT-EQUAL-" << energy.size() << endl;
		exit(EXIT_FAILURE);
	}
	
	//display the sorted values if you want
	if (display) {
		for (unsigned int i=0; i<height_sorted.size(); i++ ) {cout << "SORTED_VALUES: " << height_sorted[i] << endl;}
	}
	
	//As a percentage of the maximum value, how high should the other peaks be at minimum to be considered 
	//use 40% as the cutoff
	vector<unsigned int> peak_value;
	vector<int> peak_location;
	int checker[ height.size() ];
	for (unsigned int i=0;i<height.size();i++) {
		checker[i] = 0;
	}
	int peak_count = 0;
	unsigned int n, j;
	int how_many_peaks = 0;
	float start_energy=0;
	float stop_energy=0;
	float average = 0;
	unsigned int min_peak_breadth_inclusion = 0;
	unsigned int max_peak_breadth_inclusion = 0;
	unsigned int peak_breadth_inclusion = 0;
	if (display) cout << "The height vector is " << height.size() << " units long" << endl;
	if (display) for (unsigned int i=0;i<height.size();i++)
		cout << height[i] << endl;
	
	for (unsigned int i=0;i<height.size();i++) {
		//i will index the peak bins, starting at zero
		//The peak_breadth_inclusion should only take peaks within a fixed % of the range from the center bin
		start_energy = min + i*step; //compute the left-bin value, and index "i" at zero
		stop_energy = start_energy + step; //compute the right-bin value
		average = abs(start_energy + stop_energy) / 2;
		float percent_change = 1; //a value of 1 means a 1% range before and after the bin will be taken
		float percent_energy_difference = percent_change / 100 * average;
		//cout << "------------------" << endl;
		//cout << "REMARK:"<< percent_change << "%_ENERGY_DIFFERENCE " << percent_energy_difference << "-kcal/mol for " << average << "-kcal/mol" << endl;
		peak_breadth_inclusion = round( percent_energy_difference/step + 0.5);
		//cout << "REMARK:PEAK_BREADTH_INCLUSION-SET-TO " << peak_breadth_inclusion <<  endl;
		min_peak_breadth_inclusion = i - peak_breadth_inclusion;
		if (min_peak_breadth_inclusion < 0) {min_peak_breadth_inclusion = 0;} // only take bins that exist
		max_peak_breadth_inclusion = i + peak_breadth_inclusion;
		if (max_peak_breadth_inclusion > height.size()) {max_peak_breadth_inclusion = height.size();}
		if ( height[i] >= (0.4*height_sorted[0]) ) //must be 40% of the maximum value to be considered a peak
		{
			for (n=min_peak_breadth_inclusion;n<=max_peak_breadth_inclusion;n++)
			{
				if (checker[n] == 0 && height[n] > 0)
				{
					if (debug) cout << "DEBUG:PUSH " << n << " " << height[n] << endl;
					peak_location.push_back(n); //n is the bin number
					peak_value.push_back(height[n]); //height[n] is the peak height at bin n
					checker[n] = 1; //set the check so we don't add the peak twice
					peak_count = peak_count + 1;
					how_many_peaks = how_many_peaks + height[n];
				}
			}
		}
	}
	cout << "------------------" << endl;
	cout << "REMARK:ONLY_PRINT_OUT_HIGH_PROBABILITY_POSES" << endl;
	cout << "REMARK:DOCKED_POSES_TO_OUTPUT " << how_many_peaks << endl;
	cout << "REMARK:SIZE_CHECK " << peak_count << " " << peak_value.size() << " " << peak_location.size() << endl;
	
	if (display) for (unsigned int i=0;i<peak_value.size();i++) {
		cout << "APPENDING_HITS: " << " " << peak_location[i] << " " << peak_value[i] << endl;
	}
	
	//Use the index value "heigh_sorted[j]" to find the energy range that is represented by the highest values in the histogram ie the height vector
	float min_energy_range;
	vector<float> min_energy_range_vector;
	float max_energy_range;
	vector<float> max_energy_range_vector;
	int count;
	for (j=0;j<peak_location.size();j++) {
		min_energy_range = min + (step*peak_location[j]);
		min_energy_range_vector.push_back(min_energy_range);
		max_energy_range = min_energy_range + step;
		max_energy_range_vector.push_back(max_energy_range);
		if (peak_value[j] >= 0)
		cout << "REMARK:PEAK_INDEX_VALUE&MIN_MAX_ENERGY " << peak_location[j] << " " << peak_value[j] << " " << min_energy_range << " " << max_energy_range << endl;
	}
	
	//////////////////////
	max_pos = max; //use the maximum because we are working with negative values
    current_pos = min;
	vector<int> frame_to_bin_list;
	vector<float> energy_reordered_list;
   	while ( current_pos <= max_pos )
	{
     	energy_axis.push_back(current_pos);
        float count = 0;
		float lower = current_pos;
		float upper = (current_pos + step);
		if (debug) cout << "REMARK:Checking_energies " << lower << " to " << upper << endl;
		for (unsigned int i=0;i<energy.size();i++)
		{
			//The first bin (index zero) is special in that it includes both upper and lower bounds
			//all subsequent bins have equal signs on only the upper bound to grap the max value
			if ( (lower <= energy[i]) && (energy[i] <= upper) && (lower == min) ) {
				count = count + 1;
				if (debug) cout << "DEBUG:COMPUTE_BIN_INDEX_CHECK1 " << round( (lower-min)/step )  << " versus " << (lower-min) / step << " " << lower << " <= " << energy[i] << " <= " << upper << endl;
				frame_to_bin_list.push_back(round( (lower-min)/step )); //problem when energy is equal to upper bound
				lower_energy.push_back(lower);
				upper_energy.push_back(upper);
				frames.push_back(i);
				energy_reordered_list.push_back( energy[i] );
			} 
			if ( (lower < energy[i]) && (energy[i] <= upper) && (lower != min) ) 
			{
				count = count + 1;
				if (debug) cout << "DEBUG:COMPUTE_BIN_INDEX_CHECK2 " << round( (lower-min)/step )  << " versus " << (lower-min) / step << " " << lower << " < " << energy[i] << " <= " << upper << endl;
				frame_to_bin_list.push_back(round( (lower-min)/step )); //problem when energy is equal to upper bound
				lower_energy.push_back(lower);
				upper_energy.push_back(upper);
				frames.push_back(i);
				energy_reordered_list.push_back( energy[i] );
			}	
		}
		height.push_back(count);
		count = 0;
		//increase the counter to the end of the range
		current_pos = current_pos + step;
	}
	cout << "REMARK:BINS_ARE_INDEXED_AT_ZERO" << endl;
	int check_final_counter = 0;
	std::vector<unsigned int> nodes_to_keep;
	for (unsigned int i=0;i<peak_location.size();i++)
	{
		count = 1;
		cout << "INFO:peak_location-bin " << peak_location[i] << " and size " << peak_value[i] << endl;
		for (j=0;j<frame_to_bin_list.size();j++)
		{
			if (frame_to_bin_list[j] == peak_location[i] && energy_reordered_list[j] != min) {
					cout 	<< "REMARK:ENERGY_RUN-BIN_ELEMENT" 
							<< count 
							<< " " 
							<< frames[j]+1 
							<< " bin " 
							<< frame_to_bin_list[j] 
							<< " energy_bounds " 
							<< lower_energy[j] << " < " << energy_reordered_list[j] << " <= " << upper_energy[j] << endl;
					nodes_to_keep.push_back(frames[j]+1);
					count = count + 1;
					check_final_counter = check_final_counter + 1;
			} 
		}
	}

	///////////////////
	cout << "REMARK:KCAL_PEAK_BUFFER plus/minus_" << step*peak_breadth_inclusion << "_kcal/mol" << endl; //multiply step by plus/minus X bins away from the peak
	cout << "REMARK:PEAK_COUNT " << peak_value.size() << endl;
	cout << "REMARK:OUTPUT_VECTOR_LENGTH " << min_energy_range_vector.size() << endl;
	
	//count the number of peaks to be printed to STD out
	int height_summation = 0;
	for (unsigned i=0;i<peak_value.size();i++)
	{
		height_summation = height_summation + peak_value[i];
	}
	cout << "REMARK:PEAK_HEIGHT_SUMMATION " << height_summation << endl;
	
	//print out the min and max bin values
	cout << "REMARK:MIN-MAX " << min << " " << max << endl;
	if ( check_final_counter != how_many_peaks ) {
		print_death();
		cout << "ERROR:THE_NUMBER_OF_PEAKS_DETECTED_DOES_NOT_EQUAL_OUTPUT " << check_final_counter << " " << how_many_peaks << endl;
		exit(EXIT_FAILURE);
	} else {
		cout << "REMARK:THE_NUMBER_OF_PEAKS_DETECTED_EQUALS_OUTPUT " << check_final_counter << " " << how_many_peaks << endl;
	}
	cout << "REMARK:AFFINITY_FILTER_ENDING_NORMALLY" << endl;

	//make a vector of nodes to delete based on the nodes to keep
	for (unsigned int i=0; i<affinity.size(); i++) {
		//std::cout << "priming " << i+1 << std::endl;
		nodes_to_delete.push_back(i+1);
	}

	//sort the nodes_to_keep vector in ascending order
	std::sort (nodes_to_keep.begin(), nodes_to_keep.end(), myfunction);

	//Make a vector that will be returned to main which will contain the nodes we delete from the linked list
	for (int i=nodes_to_keep.size()-1;i>=0;i--) {
		nodes_to_delete.erase( nodes_to_delete.begin()+nodes_to_keep.at(i)-1 );
	}

	//end normally
	return;
}