
void calculate_snr( std::vector<float> histogram, std::vector<bool> isSignal, float *SNR )
{

	float Signal = 0.0;
	int nSignal = 0;
	float Noise = 0.0;
	float nNoise = 0;

	for (unsigned int i=0;i<isSignal.size();i++) {
		if ( isSignal.at(i) ) {
			nSignal++;
			Signal = Signal + histogram.at(i);
		} else {
			nNoise++;
			Noise = Noise + histogram.at(i);
		}
	}

	Signal = Signal / nSignal;
	Noise = Noise / nNoise;

	if ( Noise == 0.0 ) {
		*SNR = 0.0;
		return;
	}

	if ( Noise < 0.0001 )
		Noise = 0.0001;

	std::cout << "REMARK:SIGNAL " << Signal << std::endl;
	std::cout << "REMARK:NOISE " << Noise << std::endl;

	*SNR = log10( Signal / Noise );

	return;
}