/*

HPF = 1 / sqrt(1 + (cutoff^2 / value^2) ^ n)
n=5
cutoff = 0.618
value = histogram bin value

*/

void butterworth_hpf (std::vector<float> &histogram) 
{
	float cutoff = 0.6180339; //Golden ratio conjugate
	std::vector<float> original;
	std::vector<float> butter;
	for (unsigned int i=0;i<histogram.size();i++)
		original.push_back(histogram.at(i));

	float ratio = 0;
	for (unsigned int i=0;i<original.size();i++) {
		ratio = 0;
		ratio = ( cutoff * cutoff ) / ( original.at(i) * original.at(i) );
		ratio = ratio * ratio * ratio * ratio * ratio;
		ratio = 1 / sqrt(1+ratio);
		butter.push_back(ratio);
	}

	for (unsigned int i=0;i<histogram.size();i++) {
		histogram.at(i) = butter.at(i);
		//std::cout << "Original " << original.at(i) << " filtered " << butter.at(i) << std::endl;
	}

	return;
}